﻿// <copyright file="Subscriber.cs" company="ANUJ Technologies Inc.">
// Copyright (c) 2013 All Rights Reserved. You may use this source code as long as the copyright header is kept intact.
// </copyright>
// <author>Anuj Varma</author>
// <blog>http://www.anujvarma.com/category/technology/</blog>
// <date>11/19/2013</date>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PublishSubscribeCSharp
{
    // Subscriber class – Employee – interested in knowing when the PayrollArrived event occurs
    public class Employee 
    {
        private string _name;

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public Employee(string name)
        {
            this.Name = name;
        }

        public void OnPayrollArrival(object sender, PublisherEventArgs args)
        {
            DateTime dateToday = args.DateToFireEvent.Date;

            // Round up some friends and go spend the money!
            Console.WriteLine(this.Name + " was notified. Today is payday - date :" + dateToday);
        }
    }
}
